
  extern log_str
  extern get_proc_info
  extern ascii_to_dword
  extern lib_buf
  extern str_move

;/proc/(pid)/stat  format
; - pid
; - (process name)
; - single letter state
; - ppid parent pid
; - pgrp processing group
; - scession#
; - tty#
; - process group that owns tty, 


trace:
  pusha
  mov	esi,begin_msg
  call	log_str
;get our pid
  mov	eax,20
  int	byte 80h
  mov	[work_pid],eax	;save pid
;main loop
trace_loop:
  mov	eax,[work_pid]
  mov	ebx,1		;index for ascii name
  call	get_proc_info
  or	eax,eax
  js	trace_error
;    eax = return status, negative if error
;    ebx = ptr to string (terminated by space) or
;          binary value of item requested.
;    [lib_buf] contains /stat dir until next lib
;find parent pid and set as next work_pid
  mov	esi,lib_buf
  mov	ecx,3		;index into buffer
flp:
  lodsb
  cmp	al,' '
  jne	flp
  loop	flp
  call	ascii_to_dword
  mov	[work_pid],ecx
;move name of proc item
  mov	ebx,lib_buf
  mov	ecx,stuff_msg
  mov	edi,print_buf
p_loop:
  mov	esi,ecx
  call	str_move
  mov	ecx,esi
;move item from proc
  mov	esi,ebx
pmove:
  lodsb
  stosb
  cmp	al,' '
  jne	pmove
  mov	ebx,esi
  mov	al,' '
  stosb
;check if done with one proc item  
  cmp	[ecx],byte 0	;end of stuff_msg's
  jne	p_loop

  mov	al,0ah
  stosb			;eol

  mov	[edi],byte 0	;terminate print string
  mov	esi,print_buf
  call	log_str
;check if done (konsole pid displayed)
  mov	esi,lib_buf
done_ck:
  lodsb
  cmp	al,' '
  jne	done_ck
  inc	esi		;move past "("
  cmp	[esi],dword "kons"
  je	trace_done	;jmp if end of trace
  jmp	trace_loop

trace_error:
  mov	esi,err_msg
  call	log_str

trace_done:
  mov	esi,end_msg
  call	log_str

trace_exit:
  popa
  ret
;-----------------
  [section .data]
work_pid	dd 0
begin_msg: db 0ah,'---------------- begin block ------------------',0ah,0
end_msg:   db     '---------------- end block --------------------',0ah,0
err_msg:   db     '-error exit-',0ah,0

stuff_msg: db 'pid=',0
           db 'name=',0
           db 'state=',0
           db 'ppid=',0
           db 'pgrp=',0
           db 'sid=',0
           db 'tty#',0
           db 'tty-owner-grp=',0
           db 0		;end of table

print_buf: times 200 db 0

  [section .text]
